diff --git a/game/client/build.gradle.kts b/game/client/build.gradle.kts
index 126576088..3b7f26ad2 100644
--- a/game/client/build.gradle.kts
+++ b/game/client/build.gradle.kts
@@ -24,13 +24,21 @@ repositories {
         metadataSources { artifact() }
     }
     ivy {
-        url = uri("https://github.com/Turnip-Labs")
+        url = uri("https://github.com/Better-than-Adventure")
         patternLayout {
             artifact("[organisation]/releases/download/[revision]/[module]-bta-[revision].jar")
             m2Compatible
         }
         metadataSources { artifact() }
     }
+    ivy {
+        url = uri("https://github.com/Better-than-Adventure")
+        patternLayout {
+            artifact("[organisation]/releases/download/[revision]/brigadier-[revision].jar")
+            m2Compatible
+        }
+        metadataSources { artifact() }
+    }
 }
 
 dependencies {
@@ -52,7 +60,7 @@ dependencies {
     implementation(project(":util:logging"))?.let { include(it) }
     // </core dependencies>
 
-    implementation("legacy-lwjgl3:legacy-lwjgl3:1.0.3")?.let { include(it) }
+    implementation("legacy-lwjgl3:legacy-lwjgl3:1.0.4")?.let { include(it) }
 
     implementation("org.apache-extras.beanshell:bsh:2.0b6")?.let { include(it) }
     implementation("com.deepoove:codehighlight:1.0.3")?.let { include(it) }
diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index d3cc5142f..79ccb7266 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -1933,7 +1933,6 @@ public class Minecraft
 
         // Display Guidebook
         if (gameSettings.keyGuidebook.isPressEvent(currentInputDevice)) {
-            thePlayer.triggerAchievement(Achievements.OPEN_GUIDEBOOK);
             thePlayer.displayGuidebookScreen();
             return true;
         }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/Screen.java b/game/client/src/main/java/net/minecraft/client/gui/Screen.java
index c31c7044d..b50714c12 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/Screen.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/Screen.java
@@ -210,6 +210,7 @@ public abstract class Screen extends Gui {
     }
 
     public void guiSpecificControllerInput(ControllerInput controller) {
+        this.mouseReleased((int)controller.cursorX, (int)controller.cursorY, -1);
         if(controller.buttonB.pressedThisFrame()) {
             this.keyPressed((char)0, Keyboard.KEY_BACK, -1, -1);
         }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
index 9c63e80d4..b7d7c0ca6 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenSignEditor.java
@@ -5,6 +5,7 @@ import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
 import net.minecraft.client.input.InputType;
 import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicSign;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntitySign;
 import net.minecraft.core.enums.EnumSignPicture;
@@ -160,12 +161,12 @@ public class ScreenSignEditor extends Screen
         Block<?> block = entitySign.getBlock();
         if(block == Blocks.SIGN_POST_PLANKS_OAK)
         {
-            float signAngle = (float)(entitySign.getBlockMeta() * 360) / 16F;
+            float signAngle = (float)((entitySign.getBlockMeta() & BlockLogicSign.MASK_SIDE) * 360) / 16F;
             GL11.glRotatef(signAngle, 0.0F, 1.0F, 0.0F);
             GL11.glTranslatef(0.0F, -1.0625F, 0.0F);
         } else
         {
-            int meta = entitySign.getBlockMeta();
+            int meta = entitySign.getBlockMeta() & BlockLogicSign.MASK_SIDE;
             float signAngle = 0.0F;
             if(meta == 2)
             {
@@ -186,6 +187,7 @@ public class ScreenSignEditor extends Screen
         {
             entitySign.lineBeingEdited = editLine;
         }
+        GL11.glEnable(GL11.GL_BLEND);
         TileEntityRenderDispatcher.instance.renderTileEntity(Tessellator.instance, entitySign, -0.5D, -0.75D, -0.5D, 0.0F);
         entitySign.lineBeingEdited = -1;
         GL11.glPopMatrix();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/SliderElement.java b/game/client/src/main/java/net/minecraft/client/gui/SliderElement.java
index 4f47c75eb..dc40c1223 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/SliderElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/SliderElement.java
@@ -1,7 +1,9 @@
 package net.minecraft.client.gui;
 
+import net.minecraft.client.input.InputType;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.util.helper.MathHelper;
 import org.lwjgl.input.Mouse;
 import org.lwjgl.opengl.GL11;
 
@@ -46,15 +48,9 @@ public class SliderElement extends ButtonElement {
 		if(!visible) {
 			return;
 		}
-		final double realMouseX = (double) (Mouse.getX() * mc.resolution.getScaledWidthScreenCoords()) / mc.resolution.getWidthScreenCoords();
 		if(dragging) {
-			sliderValue = (realMouseX - (xPosition + 4)) / (float) (width - 8);
-			if(sliderValue < 0.0F) {
-				sliderValue = 0.0F;
-			}
-			if(sliderValue > 1.0F) {
-				sliderValue = 1.0F;
-			}
+			final double realMouseX = mc.inputType == InputType.CONTROLLER ? mc.controllerInput.cursorX : (double) (Mouse.getX() * mc.resolution.getScaledWidthScreenCoords()) / mc.resolution.getWidthScreenCoords();
+			sliderValue = MathHelper.clamp((realMouseX - (xPosition + 4)) / (float) (width - 8), 0, 1);
 			if(option != null) {
 				option.set((float) sliderValue);
 				displayString = option.getDisplayString();
@@ -110,14 +106,8 @@ public class SliderElement extends ButtonElement {
 	@Override
 	public boolean mouseClicked(Minecraft mc, int mouseX, int mouseY) {
 		if(super.mouseClicked(mc, mouseX, mouseY)) {
-			final double realMouseX = (double) (Mouse.getX() * mc.resolution.getScaledWidthScreenCoords()) / mc.resolution.getWidthScreenCoords();
-			sliderValue = (realMouseX - (xPosition + 4)) / (float) (width - 8);
-			if(sliderValue < 0.0F) {
-				sliderValue = 0.0F;
-			}
-			if(sliderValue > 1.0F) {
-				sliderValue = 1.0F;
-			}
+			final double realMouseX = mc.inputType == InputType.CONTROLLER ? mc.controllerInput.cursorX : (double) (Mouse.getX() * mc.resolution.getScaledWidthScreenCoords()) / mc.resolution.getWidthScreenCoords();
+			sliderValue = MathHelper.clamp((realMouseX - (xPosition + 4)) / (float) (width - 8), 0, 1);
 			if(option != null) {
 				option.set((float) sliderValue);
 				displayString = option.getDisplayString();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java b/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
index b864a15ba..09a62b274 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/TooltipElement.java
@@ -220,7 +220,7 @@ public class TooltipElement extends Gui
 
 			if(showDescription) {
 				text.append('\n').append(formatDescription(itemStack.getItemDescription(), 16));
-			} else {
+			} else if (!(slot instanceof SlotResult)) {
                 text.append('\n').append(formatDescription(trans.translateKeyAndFormat("gui.tooltip.prompt.description", mc.gameSettings.keyDescription.getKeyName()), 16));
             }
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenChat.java b/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenChat.java
index af67e6057..c191842cd 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenChat.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/chat/ScreenChat.java
@@ -16,7 +16,7 @@ import org.slf4j.Logger;
 
 public class ScreenChat extends Screen implements ITextField {
 	protected static final Logger LOGGER = LogUtils.getLogger();
-	protected String message;
+	public String message;
 	private int currentIndex = 0;
 	private String originalMessage;
 	private int updateCounter;
@@ -52,6 +52,7 @@ public class ScreenChat extends Screen implements ITextField {
 				ComponentAnchor.BOTTOM_LEFT
 			);
 			if (!this.getText().startsWith("/")) {
+
 				this.suggestionsElement.hidden = true;
 			} else {
 				this.suggestionsElement.updateSuggestions();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java
index 3ca8638d1..3a866bc28 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/ScreenGuidebook.java
@@ -14,6 +14,7 @@ import net.minecraft.client.render.entity.EntityRendererItem;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.achievement.Achievements;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
@@ -54,6 +55,7 @@ public class ScreenGuidebook
     @Override
     public void init() {
         super.init();
+        mc.thePlayer.triggerAchievement(Achievements.OPEN_GUIDEBOOK);
 
         initTabList();
         Keyboard.enableRepeatEvents(true);
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/RecipePageCrafting.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/RecipePageCrafting.java
index 350e0bdc3..2df94b267 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/RecipePageCrafting.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/crafting/RecipePageCrafting.java
@@ -70,7 +70,6 @@ public class RecipePageCrafting
     private final TooltipElement tooltipElement;
     private final ItemElement itemElement;
     private static final Minecraft mc = Minecraft.getMinecraft();
-    private static Player player;
     private static long ticks = 0;
 
     public RecipePageCrafting(GuidebookSection section, List<RecipeEntryCrafting<?,?>> recipes) {
@@ -78,8 +77,6 @@ public class RecipePageCrafting
         this.recipes = recipes;
         this.slots = new ArrayList<>();
         this.map = new HashMap<>();
-        player = mc.thePlayer;
-        player.addStat(Achievements.OPEN_GUIDEBOOK,1);
         tooltipElement = new TooltipElement(mc);
         itemElement = new ItemElement(mc);
         int recipeAmount = 0;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/smelting/RecipePageBlastSmelting.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/smelting/RecipePageBlastSmelting.java
index 34f11ecfe..bafa22b81 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/smelting/RecipePageBlastSmelting.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/smelting/RecipePageBlastSmelting.java
@@ -35,15 +35,12 @@ public class RecipePageBlastSmelting
     private final TooltipElement tooltipElement;
     private final ItemElement itemElement;
     private static final Minecraft mc = Minecraft.getMinecraft();
-    private static Player player;
     private static long ticks = 0;
     public RecipePageBlastSmelting(GuidebookSection section, ArrayList<RecipeEntryBlastFurnace> recipes) {
         super(section);
         this.recipes = recipes;
         this.slots = new ArrayList<>();
         this.map = new HashMap<>();
-        player = mc.thePlayer;
-        player.addStat(Achievements.OPEN_GUIDEBOOK,1);
         tooltipElement = new TooltipElement(mc);
         itemElement = new ItemElement(mc);
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/smelting/RecipePageSmelting.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/smelting/RecipePageSmelting.java
index 5639bf0b5..461fe1cd7 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/smelting/RecipePageSmelting.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/smelting/RecipePageSmelting.java
@@ -35,15 +35,12 @@ public class RecipePageSmelting
     private final TooltipElement tooltipElement;
     private final ItemElement itemElement;
     private static final Minecraft mc = Minecraft.getMinecraft();
-    private static Player player;
     private static long ticks = 0;
     public RecipePageSmelting(GuidebookSection section, ArrayList<RecipeEntryFurnace> recipes) {
         super(section);
         this.recipes = recipes;
         this.slots = new ArrayList<>();
         this.map = new HashMap<>();
-        player = mc.thePlayer;
-        player.addStat(Achievements.OPEN_GUIDEBOOK,1);
         tooltipElement = new TooltipElement(mc);
         itemElement = new ItemElement(mc);
 
diff --git a/game/client/src/main/java/net/minecraft/client/gui/guidebook/trommeling/RecipePageTrommel.java b/game/client/src/main/java/net/minecraft/client/gui/guidebook/trommeling/RecipePageTrommel.java
index 1d5fbceae..d8d6506b9 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/guidebook/trommeling/RecipePageTrommel.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/guidebook/trommeling/RecipePageTrommel.java
@@ -38,7 +38,6 @@ public class RecipePageTrommel
     private final TooltipElement tooltipElement;
     private final ItemElement itemElement;
     private static final Minecraft mc = Minecraft.getMinecraft();
-    private static Player player;
     private static long ticks = 0;
     private static long ticks2 = 0;
 
@@ -47,8 +46,6 @@ public class RecipePageTrommel
         this.recipes = recipes;
         this.slots = new ArrayList<>();
         this.map = new HashMap<>();
-        player = mc.thePlayer;
-        player.addStat(Achievements.OPEN_GUIDEBOOK,1);
         tooltipElement = new TooltipElement(mc);
         itemElement = new ItemElement(mc);
         int recipeAmount = 0;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
index 3d47aacdc..0c3922518 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/hud/HudIngame.java
@@ -16,6 +16,7 @@ import net.minecraft.client.gui.Gui;
 import net.minecraft.client.gui.HeldItemTooltipElement;
 import net.minecraft.client.gui.ScreenPhotoMode;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.entity.EntityRendererItem;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.core.block.BlockLogicPortal;
 import net.minecraft.core.enums.ChatVisibility;
@@ -818,6 +819,7 @@ public class HudIngame extends Gui
     public void drawChat(int width, int height, int sp)
     {
         if (mc.gameSettings.chatVisibility.value == ChatVisibility.NEVER_SHOW) return;
+        if(mc.currentScreen instanceof ScreenChat && ((ScreenChat) mc.currentScreen).message.startsWith("/")) return;
         int linesToShow = 10;
         boolean ignoreFadeout = false;
         if (mc.currentScreen instanceof ScreenChat)
diff --git a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryMinecart.java b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryMinecart.java
index a2276c73c..8f52ca544 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryMinecart.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/modelviewer/categories/entries/entity/EntityEntryMinecart.java
@@ -4,8 +4,10 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.Screen;
 import net.minecraft.client.gui.modelviewer.elements.ListenerButtonElement;
+import net.minecraft.client.gui.modelviewer.elements.ListenerSliderElement;
 import net.minecraft.core.entity.vehicle.EntityMinecart;
 import net.minecraft.core.lang.I18n;
+import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.world.World;
 import org.lwjgl.input.Keyboard;
 
@@ -22,7 +24,22 @@ public class EntityEntryMinecart extends EntityEntry<EntityMinecart>{
     public List<ButtonElement> getEntryButtons(Minecraft mc, Screen parentScreen, EntityMinecart minecart) {
         ListenerButtonElement button = new ListenerButtonElement(-1, - 120, 0, 120, 20, I18n.getInstance().translateKey("model.category.entity.minecart.button.cycle"));
         button.setActionListener(() -> minecart.setType((byte) ((minecart.getType() + 3 + (Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) ? -1 : 1)) % 3)));
-        return new ArrayList<ButtonElement>(){{add(button);}};
+        ListenerSliderElement slider = new ListenerSliderElement(-1, - 120, 21, 120, 20, I18n.getInstance().translateKeyAndFormat("model.category.entity.sheep.slider.color", "White"), 0f);
+        slider.setOnValueChanged(() -> {
+            int sliderVal = (int) (slider.sliderValue * 16) - 1;
+            if (sliderVal >= 0) {
+                DyeColor dc = DyeColor.colorFromBlockMeta(sliderVal);
+                minecart.setMeta(dc.blockMeta << 4 | EntityMinecart.TYPE_MASK_PAINTED_CHEST);
+                String color = dc.colorID;
+                String c = String.valueOf(color.charAt(0));
+                color = c.toUpperCase() + color.substring(1);
+                slider.displayString = I18n.getInstance().translateKeyAndFormat("model.category.entity.minecart.slider.color", color);
+            } else {
+                minecart.setMeta(0);
+                slider.displayString = I18n.getInstance().translateKeyAndFormat("model.category.entity.minecart.slider.color", "none");
+            }
+        });
+        return new ArrayList<ButtonElement>(){{add(button); add(slider);}};
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/FloatOptionComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/FloatOptionComponent.java
index 3ecddf448..7d817c0ee 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/FloatOptionComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/FloatOptionComponent.java
@@ -30,6 +30,7 @@ public class FloatOptionComponent
     @Override
     protected void buttonDragged(int x, int y, int width, int height, int relativeMouseX, int relativeMouseY) {
         this.option.set((float) this.slider.sliderValue);
+        this.slider.mouseDragged(mc, this.slider.xPosition + relativeMouseX, this.slider.yPosition + relativeMouseY);
         this.slider.displayString = this.option.getDisplayStringValue();
         this.option.onUpdate();
     }
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/components/KeyBindingComponent.java b/game/client/src/main/java/net/minecraft/client/gui/options/components/KeyBindingComponent.java
index 9e835cea8..1706b7973 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/components/KeyBindingComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/components/KeyBindingComponent.java
@@ -18,7 +18,8 @@ public class KeyBindingComponent
 
         this.keyBinding = keyBinding;
         this.keyButton = new ButtonElement(0, 0, 0, 150, 20, keyBinding.getKeyName());
-        this.clearButton = new ButtonElement(0, 0, 0, 12, 20, "X");
+        this.clearButton = new ButtonElement(0, 0, 0, 12, 20, "")
+            .setTextures("minecraft:gui/screen/options/clear", "minecraft:gui/screen/options/clear_highlighted", null);
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index f26273141..a9a46b332 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -1,5 +1,6 @@
 package net.minecraft.client.gui.options.data;
 
+import com.mojang.logging.LogUtils;
 import net.betterthanadventure.utils.DataDumper;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.enums.EnumGPUVendor;
@@ -15,6 +16,7 @@ import net.minecraft.client.option.enums.LightmapStyle;
 import net.minecraft.client.player.controller.PlayerControllerSP;
 import net.minecraft.client.sound.SoundEngine;
 import net.minecraft.client.util.helper.FileOpener;
+import net.minecraft.client.util.helper.JavaProcess;
 import net.minecraft.client.world.WorldClient;
 import net.minecraft.core.Global;
 import net.minecraft.core.UnexpectedThrowable;
@@ -28,6 +30,8 @@ import paulscode.sound.SoundSystem;
 
 import javax.management.RuntimeErrorException;
 import java.io.File;
+import java.io.IOException;
+import java.util.Collections;
 
 
 public abstract class OptionsPages
@@ -212,6 +216,7 @@ public abstract class OptionsPages
                 .withComponent(new KeyBindingComponent(mc.gameSettings.keySneak))
                 .withComponent(new KeyBindingComponent(mc.gameSettings.keyFly))
                 .withComponent(new KeyBindingComponent(mc.gameSettings.keyAutoWalk))
+                .withComponent(new KeyBindingComponent(mc.gameSettings.keyEasyBridge))
                 .withComponent(new KeyBindingComponent(mc.gameSettings.keySprint))
             )
             .withComponent(new OptionsCategory("gui.options.page.controls.category.user_interface")
@@ -360,7 +365,13 @@ public abstract class OptionsPages
                 .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.sound_test", () -> mc.displayScreen(new ScreenSoundTest(mc.currentScreen))))
                 .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.texture_viewer", () -> mc.displayScreen(new ScreenTextureViewer(mc.currentScreen))))
                 .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.biome_finder", () -> {
-                    new Thread(() -> SeedViewerMain.main(new String[0])).start();
+                    new Thread(() -> {
+                        try {
+                            JavaProcess.exec(SeedViewerMain.class, Collections.emptyList());
+                        } catch (final IOException | InterruptedException e) {
+                            LogUtils.getLogger().error("", e);
+                        }
+                    }).start();
                     Global.accessor = mc;
                 }))
                 .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.font_tester", () -> mc.displayScreen(new ScreenFontTest(mc.currentScreen))))
diff --git a/game/client/src/main/java/net/minecraft/client/input/PlayerInput.java b/game/client/src/main/java/net/minecraft/client/input/PlayerInput.java
index 0a6c4cea0..700a1a729 100644
--- a/game/client/src/main/java/net/minecraft/client/input/PlayerInput.java
+++ b/game/client/src/main/java/net/minecraft/client/input/PlayerInput.java
@@ -69,6 +69,11 @@ public class PlayerInput {
 		if(gameSettings.keyAutoWalk.isKeyboardKey(keyCode) && pressed) {
 			isAutoWalkOn = true;
 		}
+
+		if(gameSettings.keyEasyBridge.isKeyboardKey(keyCode) && pressed) {
+			gameSettings.easyBridge.toggle();
+			mc.hudIngame.heldItemTooltipElement.setOptionNameAndValueString(gameSettings.easyBridge);
+		}
 	}
 
 	public void onGameUnfocused() {
diff --git a/game/client/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java b/game/client/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java
index 02bc0c127..9df70381f 100644
--- a/game/client/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java
+++ b/game/client/src/main/java/net/minecraft/client/net/command/ClientCommandSource.java
@@ -25,7 +25,7 @@ public class ClientCommandSource implements CommandSource {
     }
 
     @Override
-    public Collection<String> getPlayerNames() {
+    public Collection<String> getPlayerUsernames() {
         List<String> list = new ArrayList<>();
         for (Player player : this.mc.currentWorld.players) {
             list.add(player.username);
@@ -33,9 +33,18 @@ public class ClientCommandSource implements CommandSource {
         return list;
     }
 
+    @Override
+    public Collection<String> getPlayerNicknames() {
+        List<String> list = new ArrayList<>();
+        for (Player player : this.mc.currentWorld.players) {
+            list.add(player.nickname);
+        }
+        return list;
+    }
+
     @Override
     public Collection<String> getEntitySuggestions() {
-        List<String> suggestions = new ArrayList<>(this.getPlayerNames());
+        List<String> suggestions = new ArrayList<>(this.getPlayerUsernames());
         if (this.mc.objectMouseOver != null && this.mc.objectMouseOver.entity != null) {
             suggestions.add(EntitySelector.ENTITY_PREFIX + this.mc.objectMouseOver.entity.hashCode());
         }
diff --git a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
index 2ad33bf4f..52ce4d5c1 100644
--- a/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/game/client/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -238,6 +238,7 @@ public class GameSettings {
 	public KeyBinding keySwitchPerspective = new KeyBinding("key.switchPerspective").setDefault(InputDevice.keyboard, KEY_F5);
 	public KeyBinding keyHideGui = new KeyBinding("key.immersiveMode").setDefault(InputDevice.keyboard, KEY_F1);
 	public KeyBinding keyAutoWalk = new KeyBinding("key.autoWalk");
+	public KeyBinding keyEasyBridge = new KeyBinding("key.easyBridge");
 	public KeyBinding keySprint = new KeyBinding("key.sprint");
 	public KeyBinding keyToggleOverlay = new KeyBinding("key.toggleOverlay").setDefault(InputDevice.keyboard, KEY_F4);
 	public KeyBinding keyOpenAchievements = new KeyBinding("key.openAchievements");
diff --git a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
index 702faaedf..aad6531bd 100644
--- a/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
+++ b/game/client/src/main/java/net/minecraft/client/player/controller/PlayerController.java
@@ -99,6 +99,7 @@ public abstract class PlayerController {
 				
 				if(!isMiningBlock(x, y, z)) {
 					sendStartDigPacket(x, y, z, side, xHit, yHit);
+					hitBlock(x, y, z, side, xHit, yHit);
 					currentDamage = 0.0f;
 					previousDamage = 0.0f;
 					setMineBlock(x, y, z);
diff --git a/game/client/src/main/java/net/minecraft/client/render/FogManager.java b/game/client/src/main/java/net/minecraft/client/render/FogManager.java
index 5c76b3dcf..da3ac9efc 100644
--- a/game/client/src/main/java/net/minecraft/client/render/FogManager.java
+++ b/game/client/src/main/java/net/minecraft/client/render/FogManager.java
@@ -109,7 +109,7 @@ public class FogManager {
     {
         WorldClient world = mc.currentWorld;
 
-        float renderDistanceScale = 1.0F / (float)((mc.gameSettings.renderDistance.highest + 1) - mc.gameSettings.renderDistance.value);
+        float renderDistanceScale = 1.0F / (float)((mc.gameSettings.renderDistance.highest + 8) - mc.gameSettings.renderDistance.value);
         renderDistanceScale = 1.0F - (float) Math.pow(renderDistanceScale, 0.25D);
 
         Vec3 skyColor = world.getSkyColor(mc.activeCamera, partialTick);
diff --git a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
index 3c024de83..e9807a55e 100644
--- a/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/block/model/BlockModelDispatcher.java
@@ -670,6 +670,8 @@ public final class BlockModelDispatcher
         addDispatch(new BlockModelEmpty<>(Blocks.SIGN_POST_PLANKS_OAK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/planks/oak"));
         addDispatch(new BlockModelEmpty<>(Blocks.SIGN_WALL_PLANKS_OAK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/planks/oak"));
         addDispatch(new BlockModelEmpty<>(Blocks.FLAG).setAllTextures(BLOCK_TEXTURES, "minecraft:block/planks/oak"));
+        addDispatch(new BlockModelEmpty<>(Blocks.SIGN_POST_PLANKS_OAK_PAINTED).setAllTextures(BLOCK_TEXTURES, "minecraft:block/planks/oak"));
+        addDispatch(new BlockModelEmpty<>(Blocks.SIGN_WALL_PLANKS_OAK_PAINTED).setAllTextures(BLOCK_TEXTURES, "minecraft:block/planks/oak"));
 
         addDispatch(new BlockModelLayer<>(Blocks.LAYER_SNOW).setAllTextures(BLOCK_TEXTURES, "minecraft:block/block_snow"));
         addDispatch(new BlockModelLayer<>(Blocks.LAYER_LEAVES_OAK).setAllTextures(BLOCK_TEXTURES, "minecraft:block/leaves/oak_fancy"));
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
index 724e6acfd..5d8fd8a28 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelDispatcher.java
@@ -415,6 +415,8 @@ public class ItemModelDispatcher extends Dispatcher<Item, ItemModel> {
         addDispatch(new ItemModelStandard(Items.STATUE_MARBLE, "minecraft"));
         addDispatch(new ItemModelStandard(Items.STATUE_PIGMAN, "minecraft"));
 
+        addDispatch(new ItemModelSignPainted(Items.SIGN_PAINTED));
+
         for (int i = 0; i < Blocks.blocksList.length; i++) {
             if (Blocks.blocksList[i] == null) continue;
             Item item = Blocks.blocksList[i].asItem();
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelPaintbrush.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelPaintbrush.java
index beeafa9ff..accefcc40 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelPaintbrush.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelPaintbrush.java
@@ -25,7 +25,7 @@ public class ItemModelPaintbrush extends ItemModelStandard {
 
     @Override
     public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack) {
-        final DyeColor color = ((ItemPaintBrush) itemStack.getItem()).getColor(itemStack);
+        final DyeColor color = ItemPaintBrush.getColor(itemStack);
         if (color == null) {
             return emptyIcon;
         }
